// Specific STEP Connector API
let userPrompts = require("../../userPrompts");
let STEP = require('node-step');
let util = require('util');
const readline = require('readline');
const rl = readline.createInterface(process.stdin, process.stdout);

module.exports = function(stepModel) {

/**
 * readStepFileParts
 * @param {stepFile} stepFile Request
 * @callback {Function} callback Callback function
 * @param {Error|string} err Error object
 * @param {any} result Result object
 */
stepModel.readStepFileParts = function(stepFile, callback) {

	var s = STEP.readStep.readStep(stepFile, function callback(){console.log("Done");});
	//console.log(s);
    callback(result);
	
}


stepModel.checkStepFile = function(filename, callback)
{
	var result=STEP.check_STEP_file(filename, function(err, data) {
			if (err) {
				console.log("failure :" + err);
			return;}
			else
			{	//console.log("data: " + data);
				//console.log("the file is correct");
				callback("The file is correct");
			return;}
	});
}


stepModel.remoteMethod('readStepFileParts',
	{ 
	    isStatic: true,
	    produces: ['application/json'],
	    http: { verb: 'post', path: '/readStepFileParts' },
	    accepts: 
	    [ 
	        { 
	          arg: 'stepFile',
	          type: 'file',
	          description: 'STEP file Request',
	          required: false,
	          'http': {source: 'query'}
	        } 
	    ],
	    returns: {arg: 'result', type: 'string'},
	    description: undefined 
	}
);

stepModel.remoteMethod('checkStepFile',
	{ 
	    isStatic: true,
	    produces: ['text/xml'],
	    http: { verb: 'post', path: '/checkStepFileParts' },
	    accepts: 
	    [ 
	        { 
	          arg: 'stepFile',
	          type: 'file',
	          description: 'STEP file Request',
	          required: false,
	          'http': {source: 'query'}
	        } 
	    ],
	    returns: {arg: 'result', type: 'string'},
	    description: undefined 
	}
);


function readStepFile(fileName) 
{

	reader.read(fileName,function(err) {
			if (err) {
				console.log("failure :" + err);
				return;
			}
			var product_definitions = reader.getObjects("PRODUCT");
			
 // "PRODUCT_DEFINITION_FORMATION",
    // "PRODUCT_DEFINITION_FORMATION_WITH_SPECIFIED_SOURCE",
    // "PRODUCT_DEFINITION_CONTEXT",
    // "PRODUCT_DEFINITION",
    // "DESIGN_CONTEXT",
    // "PRODUCT",
    // "PRODUCT_CONTEXT",
    // "MECHANICAL_CONTEXT",
    // "APPLICATION_CONTEXT",
    // "SHAPE_DEFINITION_REPRESENTATION",
    // "REPRESENTATION_RELATIONSHIP",
    // "REPRESENTATION_RELATIONSHIP_WITH_TRANSFORMATION",
    // "SHAPE_REPRESENTATION_RELATIONSHIP",
    // "PROPERTY_DEFINITION",
    // "SHAPE_DEFINITION_REPRESENTATION",
    // "PRODUCT_DEFINITION_SHAPE",
    // "PRODUCT_DEFINITION_USAGE",
    // "ASSEMBLY_COMPONENT_USAGE",
    // "NEXT_ASSEMBLY_USAGE_OCCURRENCE",
    // "MAPPED_ITEM",
    // "REPRESENTATION_MAP",
    // "AXIS2_PLACEMENT_3D",
    // "REPRESENTATION_ITEM",
    // "REPRESENTATION_CONTEXT",
    // "REPRESENTATION",
    // "SHAPE_REPRESENTATION",
    // "ADVANCED_BREP_SHAPE_REPRESENTATION",
    // "FACETED_BREP_SHAPE_REPRESENTATION",
    // "GEOMETRIC_REPRESENTATION_ITEM",
    // "GEOMETRIC_REPRESENTATION_CONTEXT",
    // "GLOBAL_UNIT_ASSIGNED_CONTEXT",
    // "GLOBAL_UNCERTAINTY_ASSIGNED_CONTEXT",
    // "SOLID_MODEL",
    // "MANIFOLD_SOLID_BREP",
    // "BREP_WITH_VOIDS",
    // "FACETED_BREP",
    // "TOPOLOGICAL_REPRESENTATION_ITEM",
    // "FACE",
    //"ADVANCED_FACE",
    // "FACE_BOUND",
    // "FACE_OUTER_BOUND",
    // "LOOP",
    // "EDGE_LOOP",
    // "SURFACE",
    // "SHAPE_ASPECT",
    // "PRODUCT_DEFINITION_WITH_ASSOCIATED_DOCUMENTS",
    // "GEOMETRICALLY_BOUNDED_SURFACE_SHAPE_REPRESENTATION",
    //"TRIMMED_CURVE",
    // "DEFINITIONAL_REPRESENTATION",
    // "PARAMETRIC_REPRESENTATION_CONTEXT",
    // "CARTESIAN_POINT",
    // "DIRECTION",
    // "CLOSED_SHELL",
    // "REPRESENTATION_RELATIONSHIP",
    // "REPRESENTATION_RELATIONSHIP_WITH_TRANSFORMATION",
    // "SHAPE_REPRESENTATION_RELATIONSHIP",
    // "GEOMETRIC_REPRESENTATION_CONTEXT",
    // "GLOBAL_UNCERTAINTY_ASSIGNED_CONTEXT",
    // "GLOBAL_UNIT_ASSIGNED_CONTEXT",
    // "REPRESENTATION_CONTEXT"
			
	return util.inspect(product_definitions, false, null);
//			reader.dumpStatistic();
		}
	);
}



}
